/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _EVENTWATCHER_H_
#define _EVENTWATCHER_H_

#include <kmainwindow.h>
#include "systemtray.h"

namespace EventWatcher {

class SystemTray;
class Plugin;
class EventData;
class PopupManager;
class EventContainer;
class MainWidget;

class eventwatcher : public KMainWindow
{
    Q_OBJECT
public:
    eventwatcher();
    virtual ~eventwatcher();
    SystemTray* systemTray() const { return m_systemTray; };
signals:
    void settingsChanged();
public slots:
    void setupPlugin(Plugin* p);
    void eventPopup(const EventData&);
    void minimizeRestore(bool restore = true);
    void slotQuit() { m_shuttingDown = true; kapp->quit(); }
protected:
    virtual bool queryClose();
private slots:
    void optionsConfigureToolbars();
    void optionsPreferences();
private:
    void setupActions();
    void setupSystemTray();

    bool m_shuttingDown;

    MainWidget *m_mainWidget;
    SystemTray *m_systemTray;
    PopupManager *m_popupManager;
    EventContainer *m_eventContainer;
};

};

#endif // _EVENTWATCHER_H_
