/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qcheckbox.h>
#include <qlabel.h>
#include <qspinbox.h>

#include "config.h"
#include "generalsettingpageimp.h"

namespace EventWatcher {

GeneralSettingPageImp::GeneralSettingPageImp(QWidget *parent, const char *name)
 : GeneralSettingPage(parent, name)
{
//     connect( kcfg_PopupEnabled, SIGNAL(toggled(bool)), kcfg_PopupCloseDelay, SLOT(enabled(bool)) );
//     connect( kcfg_PopupEnabled, SIGNAL(toggled(bool)), delayLabel, SLOT(enabled(bool)) );
//     connect( kcfg_PopupEnabled, SIGNAL(toggled(bool)), kcfg_PopupShowDetails, SLOT(enabled(bool)) );
    connect( kcfg_PopupEnabled, SIGNAL(toggled(bool)), this, SIGNAL(changed()) );
    connect( kcfg_PopupShowDetails, SIGNAL(toggled(bool)), this, SIGNAL(changed()) );
    connect( kcfg_PopupCloseDelay, SIGNAL(valueChanged(int)), this, SIGNAL(changed()) );

    kcfg_PopupEnabled->setChecked( Config::popupEnabled() );
    kcfg_PopupShowDetails->setChecked( Config::popupShowDetails() );
    kcfg_PopupCloseDelay->setValue( Config::popupCloseDelay() );

    kcfg_PopupShowDetails->setEnabled( Config::popupEnabled() );
    kcfg_PopupCloseDelay->setEnabled( Config::popupEnabled() );
    delayLabel->setEnabled( Config::popupEnabled() );
}


GeneralSettingPageImp::~GeneralSettingPageImp()
{
}

void GeneralSettingPageImp::slotApply()
{
    Config::setPopupEnabled( kcfg_PopupEnabled->isChecked() );
    Config::setPopupShowDetails( kcfg_PopupShowDetails->isChecked() );
    Config::setPopupCloseDelay( kcfg_PopupCloseDelay->value() );
    Config::writeConfig();
}

void GeneralSettingPageImp::slotDefaults()
{
    kcfg_PopupEnabled->setChecked(true);
    kcfg_PopupShowDetails->setChecked(false);
    kcfg_PopupCloseDelay->setValue(5);
}

};
#include "generalsettingpageimp.moc"
