/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//#include <kuniqueapplication.h>
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

#include "eventwatcher.h"

static const char description[] =
    I18N_NOOP("An Event Notification Application");

static const char version[] = "0.4.2";

static KCmdLineOptions options[] =
{
//    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("eventwatcher", I18N_NOOP("eventwatcher"), version, description,
                     KAboutData::License_LGPL, "(C) 2004 Sandro Giessl", 0, 0, "ceebx@users.sourceforge.net");
    about.addAuthor( "Sandro Giessl", 0, "ceebx@users.sourceforge.net" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KApplication app;

    EventWatcher::eventwatcher *mainWin;

//     if (app.isRestored())
//     {
//         RESTORE(EventWatcher::eventwatcher);
//     }
//     else
//     {
        // no session.. just start up normally
        mainWin = new EventWatcher::eventwatcher();
        mainWin->hide();
//     }

    app.setMainWidget(mainWin);

    // mainWin has WDestructiveClose flag by default, so it will delete itself.
    return app.exec();
}

