/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EVENTWATCHERPLUGINMANAGER_H
#define EVENTWATCHERPLUGINMANAGER_H

#include <qobject.h>

#include <kservice.h>

// #include "plugin.h"

namespace EventWatcher {

class Plugin;
class KPluginInfo;

class PluginInfo
{
public:
    bool loaded;
    KService::Ptr service;
    Plugin *plugin;

    // plugin settings
    bool enabled;
};

typedef QValueList<PluginInfo> PluginInfoList;

class PluginManager : public QObject
{
Q_OBJECT
public:
    ~PluginManager();

    void loadEnabledPlugins();
    void unloadPlugins();
    void loadPlugin(PluginInfo& info);
    void unloadPlugin(PluginInfo& info);

//     const PluginInfoList& pluginInfoList() const;

public slots:
    void settingsChanged();

signals:
    void pluginCreated(Plugin* p);

private:
    friend PluginManager* pluginManager();
    PluginManager(QObject *parent = 0, const char *name = 0);

    void fetchPluginList();
    void readConfig();

    PluginInfoList m_pluginInfoList;
};

};

#endif
