/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _PLUGIN_EVENTWATCHER_DCOP_H_
#define _PLUGIN_EVENTWATCHER_DCOP_H_

#include "../../lib/plugin.h"

#include <klibloader.h>

#include "dcoppluginiface.h"

class Factory : public KLibFactory
{
Q_OBJECT
public:
    Factory();
    virtual ~Factory();

    virtual QObject* createObject( QObject* parent = 0, const char* pname = 0,
       const char* name = "QObject", const QStringList &args = QStringList() );

private:
    static KInstance* s_instance;
};

class DcopPlugin : public EventWatcher::Plugin, virtual public DcopPluginIface
{
Q_OBJECT
public:
    DcopPlugin( QObject* parent = 0, const char* name = 0 );
    virtual ~DcopPlugin();

    virtual void send(const QString &shortTitle, const QString &title);
    virtual void send(const QString &shortTitle, const QString &title, const QString &text);
    virtual void send(const QString &shortTitle, const QString &title, const QString &text, const QString &icon);
public slots:
    virtual void settingsChanged();
    virtual void onlineSettingChanged() {}; // irrelevant for dcop...
    virtual void performUpdateCheck() {}; // irrelevant for dcop...
};

#endif
