/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _PLUGIN_EVENTWATCHER_LOG_H_
#define _PLUGIN_EVENTWATCHER_LOG_H_

#include "../../lib/plugin.h"

#include <klibloader.h>
#include <kurl.h>

class QTimer;

namespace EventWatcherLogPlugin {

class Factory : public KLibFactory
{
Q_OBJECT
public:
    Factory();
    virtual ~Factory();

    virtual QObject* createObject( QObject* parent = 0, const char* pname = 0,
       const char* name = "QObject", const QStringList &args = QStringList() );

private:
    static KInstance* s_instance;
};

class LogPlugin : public EventWatcher::Plugin
{
Q_OBJECT
public:
    LogPlugin( QObject* parent = 0, const char* name = 0 );
    virtual ~LogPlugin();
public slots:
    virtual void settingsChanged();
    virtual void onlineSettingChanged();
    virtual void performUpdateCheck();
    void update();
private:
    class SourceInfo
    {
    public:
//         SourceInfo() : file(0) {}
//         ~SourceInfo() {
//             if( file && file->isOpen() )
//                 file->close();
//             delete file;
//         }
        QFile /***/file;
        QString url;
        QColor color;
    };
    typedef QPtrList<SourceInfo> SourceInfoList;

    void readConfig();
    QTimer *m_timer;
    int m_interval;
    SourceInfoList m_sources;
    QStringList m_filters;
};

};

#endif
