/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _PLUGIN_EVENTWATCHER_RSS_H_
#define _PLUGIN_EVENTWATCHER_RSS_H_

#include <qmap.h>
#include <qtimer.h>

#include "../../lib/plugin.h"

#include <klibloader.h>
#include <kurl.h>

#include <dcopobject.h>
#include <dcopref.h>

// #include <rss/document.h>
// #include <rss/global.h>
// #include <rss/loader.h>

class QTimer;

namespace EventWatcherRssPlugin {

typedef QMap<QString,bool> HeadlineList;

typedef QValueList<DCOPRef> FeedList;

class Factory : public KLibFactory
{
public:
    Factory();
    virtual ~Factory();

    virtual QObject* createObject( QObject* parent = 0, const char* pname = 0,
       const char* name = "QObject", const QStringList &args = QStringList() );

private:
    static KInstance* s_instance;
};

class RssPlugin : public EventWatcher::Plugin, public DCOPObject
{
Q_OBJECT
K_DCOP

public:
    RssPlugin( QObject* parent = 0, const char* name = 0 );
    virtual ~RssPlugin();

k_dcop:
    void documentUpdated( DCOPRef ref );
    void documentRemoved( QString url );

public slots:
    virtual void settingsChanged();
    virtual void onlineSettingChanged();
    virtual void performUpdateCheck();

protected slots:
    void initDocuments();
    void refreshDocuments();
private:
    void readConfig();
    HeadlineList getOldHeadlines(const QString& newsFeed);
    void setOldHeadlines(HeadlineList& headlines, const QString& newsFeed);
    QTimer m_refreshTimer;
    int m_interval;
    QStringList m_sources;
    FeedList m_feeds;
    bool m_serviceAvailable;
    bool m_initialized;
};

};

#endif
