/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qbutton.h>
#include <qpainter.h>
// #include <qwidget.h>

#include "plusminusbutton.h"

namespace EventWatcher {

#define PLUSMINUS_SIZE 11

PlusMinusButton::PlusMinusButton(QWidget *parent, const char *name) : QButton(parent,name)
{
    setToggleButton( true );
    setBackgroundMode( NoBackground );
    setFixedSize(sizeHint());
}

PlusMinusButton::~PlusMinusButton()
{}

void PlusMinusButton::setOn(bool on)
{
    QButton::setOn(on);
}

QSize PlusMinusButton::sizeHint()
{
    return QSize(PLUSMINUS_SIZE,PLUSMINUS_SIZE);
}

void PlusMinusButton::paintEvent(QPaintEvent *)
{
    QRect r = rect();
    QPainter p(this);
    p.fillRect( r.x()+1, r.y()+1, r.width()-1, r.height()-1, isEnabled()?colorGroup().base():colorGroup().midlight() );
    p.setPen(isEnabled()?colorGroup().foreground():colorGroup().dark() );
    p.drawRect( r );
    p.drawLine( r.x()+3, r.y()+r.height()/2, r.right()-3, r.y()+r.height()/2 );
    if( isOn() )
        p.drawLine( r.x()+r.width()/2, r.y()+3, r.x()+r.width()/2, r.bottom()-3 );
    p.end();
}

};
