/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   based on KopeteBalloon:                                               *
 *   Copyright (c) 2002      by Duncan Mac-Vicar Prett <duncan@kde.org>    *
 *   Kopete    (c) 2002-2003 by the Kopete developers  <kopete-devel@kde.org> *
 *   Portions of this code based on Kim Applet code                        *
 *   Copyright (c) 2000-2002 by Malte Starostik        <malte@kde.org>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EVENTWATCHERPOPUPMANAGER_H
#define EVENTWATCHERPOPUPMANAGER_H

#include <qmap.h>
#include <qpoint.h>
#include <qwidget.h>

class QLabel;
class QPushButton;
class QTimer;

namespace EventWatcher {

class EventItem;
class MainWidget;

class PopupManager : public QWidget
{
Q_OBJECT
public:
    PopupManager(MainWidget *parent);
    ~PopupManager();

    void setAnchor(const QPoint &anchor);
//     void add(const EventView& view);
public slots:
    void slotClose();
    void slotEventAdded(EventItem*);
    void slotSetShowDetails(bool show);
signals:
    void restoreMainWindow();
private slots:
    void slotUpdateTimerTimeout();
protected:
    virtual void updateMask();
    virtual void mouseReleaseEvent( QMouseEvent *e );
private:
    typedef QMap<QString,int> EventPopupBuffer;

    MainWidget *m_parent;
    QTimer *m_closeTimer, *m_updateTimer;
    QLabel *m_label,
           *m_shortTitleLabel;
    QPushButton *m_viewButton,
                *m_detailsButton;

    EventPopupBuffer m_eventBuffer;

    QPoint m_anchor;
};

};

#endif
