/***************************************************************************
 *   Copyright (C) 2004 by Sandro Giessl                                   *
 *   ceebx@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EVENTWATCHERSETTINGSDIALOG_H
#define EVENTWATCHERSETTINGSDIALOG_H

#include <kdialogbase.h>

namespace EventWatcher {

class GeneralSettingPageImp;
class PluginSettingPage;

/**
@author Sandro Giessl
*/
class SettingsDialog : public KDialogBase
{
Q_OBJECT
public:
    SettingsDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);
    ~SettingsDialog();

//     void updateDialog();
    void updateConfiguration(); // transfer settings to configuration object

public slots:
    void slotApply();
    void enableApply();
signals:
    void settingsChanged();
private:
    GeneralSettingPageImp *m_generalPage;
    PluginSettingPage *m_pluginPage;

};

};

#endif
